# answers_to_code_design_qs.py 
# solution version
# Sources/people consulted: NONE
# Apr 27, 2021
# Skeleton by Prof. Lillian Lee (LJL2), Apr 27, 2021


# STUDENTS
# Please make sure your lines are <= 80 characters long.


#### Q1 ####
# In file college_a5.py, are there any advantages to changing `add_student` and
# `was_accepted`, which were non-method functions in A3, into methods of
# class College? 
#
# * If so, explain what the advantages are.
#
# * If not, explain why it makes no difference or is even detrimental to 
#   switch these non-method functions to methods.
#
# Note; answers that don't mention the specific class College are likely to
# be too vague.
#
'''
#### A1 ####
# STUDENTS: put your answer within these triple quotes.
# A paragraph of 1-4 sentences should suffice


# BEGIN REMOVE
With a function call f(.., c), where c is supposed to be a College,
it's possible for a caller to accidentally supply a `c` of the wrong
type.

In contrast, method calls always involve reference to College object, 
and so can't be called for a non-College object, eliminating one possible
error source and/or making the fact that this method is for one specific class 
only more clear.

It also makes sense that adding a student is an action that a College would take,
and that accepting a student is an action that a College would take;
a call like <some college>.add_student(<student>) mimics this intuition 
nicely.

# END REMOVE




'''

#### Q2 ####
# Is there any function in sd_utilities_list.py that would be better to
# convert to a method (an instance method) of class Showdown or College?
#
# * If so, name one and explain why it would be advantageous to convert
#   to a method.
#
# * If not, name one and explain why it would make no difference or even
#   be detrimental to switch it to a method.
'''
#### A2 ####
# STUDENTS: put your answer within these triple quotes.
# A paragraph of 1-4 sentences should suffice


# BEGIN REMOVE
None should be converted to (instance) methods.

colleges_from_file(), process_list(), and prompt_for_data() can be invoked even 
if no College objects yet exist so they shouldn't be called with respect to a 
specific College or Showdown object.

college_named() and menu_listing() don't take a single College or Showdown object
as argument, which is a sign that they shouldn't be methods.  It would be 
strange to see a call like cornell.college_named("Ithaca College", <clist>) or
cornell.college_named("Cornell", <clist>); there's no need to have the College
object cornell for either of those calls. For the same reason, it would also be 
strange to see a call like cornell.menu_lsting(<list of colleges>).  


# END REMOVE




'''
#### Q3 ####
# Is there any advantage to converting the for-loop in 
# sd_utilities_list.college_named() to be a while-loop that can terminate early?
'''
#### A3 ####
# STUDENTS: put your answer within these triple quotes.
# A paragraph of 1-4 sentences should suffice.

# BEGIN REMOVE
No.  The `return` statement causes the for-loop to stop as soon as
a College with the specified name is found.  Using a while-loop would 
not speed things up, and would require more book-keeping with remembering
to increment the loop variable.
# END REMOVE


'''
